//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated 2018.07.22 14:27:40 from knowledge.txt
//////////////////////

#ifndef KNOWLEDGE_H
#define KNOWLEDGE_H

// for uint*_t
#include <stdint.h>
#include <avr/pgmspace.h>


/*
struct S_Line {
	uint8_t eline[16];	// direct line
// encoded line of 16 halfbytes is not possible - too many values
	};
*/
# define S_Line char
struct S_Unit {
	const char *name;
	const char *comment;
	const S_Line *start;
	const S_Line *end;	// this is START of NEXT unit, does not belong to me
	uint16_t test_inputs,test_inputs_mask;
	uint16_t test_outputs,test_outputs_mask;
	uint8_t TP;	// Total pins: 14/16 
	uint8_t AP;	// Active pins: 12/14
	};
extern const char line_decoder[][16];	// decoding halfbytes to chars, defined in knowledge_decoder.cpp.cpp
extern const PROGMEM S_Line lines[];
extern const S_Unit units[];
extern const uint16_t number_of_units;
extern const PROGMEM char names[];
extern const PROGMEM char comments[];
	

#endif
