#ifndef MYPROGMEMTOOLS_H
#define MYPROGMEMTOOLS_H
// Tools for PROGMEM, debugging and such
// {{{ F() what the F** it does? (put string to PROGMEM and enables print() print it)
//    Serial.print(F("some string"));
//    https://forum.arduino.cc/index.php?topic=91314.0
//    __extension__ prevents GCC -pedantic warnings within following one  expression
//    From Arduino (hope):
//    # define PSTR(s) (__extension__({static char __c[] PROGMEM = (s); &__c[0];}))
//    // create PROGMEM string, "returns" its address ( see https://gcc.gnu.org/onlinedocs/gcc/Statement-Exprs.html )
//    class __FlashStringHelper; // Special class for selecting print(..) version by parameter type
//    #define F(string_literal) (reinterpret_cast<__FlashStringHelper *>(PSTR(string_literal)))
//    // reinterpret_cast changes PSTR return type of char * to __FlashStringHelper *
//    so  print(const __FlashStringHelper *) is called rather than print(const char[])
// }}}
// FF(char *msg) // just enable print() print already defined msg from PROGMEM
#define FF(msg) ((const __FlashStringHelper *)(msg))
#endif
